/****************************************************************************
*** VOICE/SILENCE DETECTOR - VoSiD		by Sampo Savolainen 1996 *****
*******************************************************************************
*** This is a very simple program, which checks if the mic is receiving any ***
*** sound beyond the background noise. This program can me modified to work ***
*** i.e. as a VERY cool sound-trigger by changing the "while" in the main   ***
*** loop to while( voice_b == 0) { blah blah.. } then VoSiD would stop when ***
*** the program detects noise. 	                                            ***
*** The visualization of the elements is crap at the moment, but hey, they  ***
*** do the job.								    ***
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <math.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "vosid.h"


/********************************
*************** MAIN FUNCTION ****
*********************************/
void main(int argc, char **argv)
{
 int orig_vol,
     new_vol,
     noise,
     silence_c,
     silence_b,
     voice_b,
     clrs_b,
     quit_b,
     x;

 parser(argc,argv);

/********* CREATING A SIN WAVE */
 for (x=0; x<PINGSIZE; x++) wave[x]=sin(x+1)*(128/(x/PINGSIZE+0.001))+128;

 x = silence_c = quit_b = 0;

/********* OPENING THE DEVICES */
 
 dsp	 = open (DSP_DEVICE,O_RDWR);
 if (dsp==-1) { printf ("Error opening %s, errno: %d\n",
                        DSP_DEVICE,
                        errno);
                exit (-1); }
 
 mixer	 = open (MIXER_DEVICE,O_RDWR);
 if (mixer==-1) { printf ("Error opening %s, errno: %d\n",
                          MIXER_DEVICE,
                          errno);
                  exit (-1); }

/********* OPENING SEQUENCE */
 printf("VoSiD %s		by Sampo Savolainen 1996\n",VERSION);

/********* SAVING&DEFINING MIC VOLUME */
 ioctl (mixer,MIXER_READ(7),&orig_vol);
 
 new_vol = (100 & 0xff) | ((100 & 0xff) << 8);
 ioctl (mixer,MIXER_WRITE(7),&new_vol);


/********* SOUND PARAMETERS */
 x=SAMPLING_BITS;
  ioctl (dsp, SOUND_PCM_WRITE_BITS,     &x);

 x=MONO;
  ioctl (dsp, SOUND_PCM_WRITE_CHANNELS, &x);

 x=SAMPLING_RATE;
  ioctl (dsp, SOUND_PCM_WRITE_RATE,     &x);


/********* NOISE CHECK */
 printf ("Measuring noise level, please be quiet.\n");
 noise   = get_noise();
 printf ("Noise level %d\n",noise);
 
 printf("Starting silence/voice detector:\n");

 silence_c=SENSIBILITY+1;
 x=0; 

 voice_b = silence_b = 0;


/****************************************************************
********* MAIN LOOP************************************************
**** In this while you can change the way this program works	****
**** i.e. a sound-trigger would be "while (voice_b==0)"		****
********** *  *   *    *     *     *     *    *   *  * *************
**** voice_b      a fake-boolean, 1 when voice is heard, 0	****
****              when not.					****
**** silence_b    a fake-boolean, 1 when silent, 0 when not.	****
**** quiet_b      a fake-boolean, 1 stop loop, 0 continue.	****
**** silence_c    silence counter, every sampling which is	****
****              within the "noise" range, is counted here,	****
****              when voice is heard, this counter is 0'ed.	****
********************************************************************
**** Original "silence_c > SAMPLING_RATE*10"			****
*******************************************************************/

 while (quit_b==0)
 {
   read(dsp,l,1);
  
   if ( abs(l[0]-128) < noise+1 ) silence_c++; else silence_c=0;
                                                                 
   if (silence_b == 0) if (silence_c>SENSIBILITY) {
                                                    voice_b=0;
                                                    silence_b=1;
                                                    if (verbose_b==1)
                                                     printf("Silence\n");
                                                   }
   if (voice_b   == 0) if (silence_c<SENSIBILITY) {
       						   voice_b=1;
                                                   silence_b=silence_c=0;
                                                   if (verbose_b==1)
                                                    printf("Voice\n");
                                                   if (quiet_b==0) ping();
                                                  }
   if (sstyle==1) if (silence_c > SAMPLING_RATE*10) 	quit_b=1;
   if (sstyle==2) if (voice_b   == 1)			quit_b=1;
   if (sstyle==3) if (silence_b == 1)			quit_b=1;
 }

/********* RESTORING VALUES */
 printf ("Deinitializing...");
 ioctl  (mixer, MIXER_WRITE(7), &orig_vol); 
 printf (".");
 close  (dsp);
 printf (".");
 close  (mixer);
 printf ("...Done\n");
}